#pragma glslify: import('../common.glsl')

#define WAVE_COUNT 6.

float glow(float x, float dist){
  return smoothstep(x-0.025, x+0.025, dist);
}

// Sinus Signed Distance Function (distance field)
float sinSDF(float vol, float index, vec2 st, float A, float offset, float f, float phi){
    return abs((st.y - offset) + sin((1.0 + index/.9) * (1. + vol * 1.) * st.x * f + phi) * A * (vol * 7.));
}

void main()
{
    vec2 st = (gl_FragCoord.xy-0.5*u_resolution.xy) / u_resolution.y + 0.5;
    vec3 col = vec3(0.0);
    float time = u_time/2.0;
    float dist = 0.012;

    float timeHalfInv = -u_time * sign(st.x-0.5);
    float am = cos(st.x*3.0); // Amplitude modulation
    float offset = 0.5+sin(st.x*12.0+time)*am*0.05;
    for(float i = 0.0; i<WAVE_COUNT ; i++){
        float vol = getFrequencyValue((i - 1.)/WAVE_COUNT, 0);
        vec3 color = getTweenedTexture(u_palette, (i-1.)/WAVE_COUNT).rgb;
        col += glow(sinSDF(vol, i, st, am*0.200, offset, 6., timeHalfInv+i*2.000*PI/WAVE_COUNT), dist) * color * (vol + 0.8);
    }

    // Output to screen
    gl_FragColor = vec4(col, 0.);
}