export function interpolate(data, fitCount) {
  const linearInterpolate = (before, after, atPoint) => before + (after - before) * atPoint;

  const newData = [];
  const springFactor = (data.length - 1) / (fitCount - 1);
  newData[0] = data[0];

  for( let i = 1; i < fitCount - 1; i += 1) {
    const tmp = i * springFactor;
    const before = Math.floor(tmp);
    const after = Math.ceil(tmp);
    const atPoint = tmp - before;
    newData[i] = linearInterpolate(data[before], data[after], atPoint);
  }

  newData[fitCount - 1] = data[data.length - 1];
  return newData;
}

export function smooth(smoothData, data, i, alpha) {
  smoothData[i] = (data[i] * alpha) + ((smoothData[i] || 0) * (1 - alpha));
}
