#pragma glslify: import('../common.glsl')

#define BOOST 3.
#define STEPS 32.
#define THICKNESS .005

void main() {
    vec2 uv = gl_FragCoord.xy/u_resolution.xy;
    uv.y /= u_resolution.x / u_resolution.y;

    vec4 color = vec4(0.);
    bool drawn = false;

    for (float i = 0.; i < STEPS - 1.; i += 1.) {
        float dim = 1.0 - (i/STEPS/1.2);
        float offset = i/STEPS * 0.7 + 0.01 - 0.003 * i;

        if (!drawn) {
            float history = mod(u_frequencyHistoryIndex - i, STEPS)/STEPS;
            float level = vectorToFloat(texture2D(u_frequencyHistory, vec2(uv.x, history)));
            float vol = level * pow(0.5 - abs(uv.x - 0.5), 1.7) * BOOST;
            float line = offset + vol;
            float linePct = smoothstep(line-THICKNESS, line, uv.y) - smoothstep(line, line+THICKNESS, uv.y);

            color = vec4(linePct);
            color.a = color.a * dim;
            drawn = uv.y < (offset + vol + THICKNESS);
        }
    }

    gl_FragColor = color;
}
