#pragma glslify: import('../common.glsl')

void main()
{
  float time = u_time / 3.0;
  vec2  uv = gl_FragCoord.xy / u_resolution.xy;
  float color = 0.;

  // Use the volume to make some vertical lines on the background.
  float vol = getFrequencyValue(uv.x, FREQ_AMPLITUDE);
  float bgMultiplier = (.8 - color + 1.5 * vol);

  // Distort the background a little with the volume, just to make it more interesting.
  gl_FragColor = bgMultiplier * vec4(getTweenedTexture(u_palette, uv.y - vol / 4.0).rgb, 1.0);

  // Now give everything a really vignetted overlay.
  gl_FragColor *= 5.0 * sqrt(uv.x*uv.y*(1.-uv.x)*(1.-uv.y));

  // And use some alpha to make it more ghostly and enhance the vertical patterns a bit.
  gl_FragColor.a = 0.65 - vol / 2.;
}
