#pragma glslify: import('../common.glsl')

void main()
{
  // Build a line from the center to the point we're rendering.
  vec2 uv = gl_FragCoord.xy / u_resolution.xy;
  uv.x *= u_resolution.x/u_resolution.y;
  vec2 line = vec2(0.5*u_resolution.x/u_resolution.y, 0.5) - uv;

  // Get angle from 0 to 1 and read the amplitude.
  float angle = atan(line.y, line.x) / TWO_PI + 0.5;

  // Compute the radius of the line.
  float r = length(line);
  r -= sin(15.0 * (0.5 - getFrequencyValueBilinear(r, FREQ_AMPLITUDE)) + angle*TWO_PI*6.0)/30.0;

  // Build concentric glowing rings with the radius, which grow over time.
  float z = 1.5/sqrt(abs(sin(r*25.0 - u_time)));

  // Color based on distance from origin.
  vec3 col = getTweenedTexture(u_palette, length(line) * 1.5).rgb * 0.2;

  gl_FragColor = vec4(col * vec3(z), sqrt(length(col * vec3(z))));
}
