#pragma glslify: import('../common.glsl')

#define ANGLE_OFFSET 0.25

void main( void )
{
  vec2 uv = gl_FragCoord.xy/u_resolution.xy;
  uv.x *= u_resolution.x/u_resolution.y;
  uv.y -= 0.5;
  uv.x -= 0.5 * (u_resolution.x/u_resolution.y);
  float angle = mod(atan(uv.y, uv.x) / (2.*PI) - ANGLE_OFFSET, 1.);
  float vol = getFrequencyValueBilinear(length(uv - vec2(0., 0.)), 0);
  float vol2 = getFrequencyValueBilinear(uv.x + 0.5, 0);

  vec2 p = uv*3.000;
  float a = atan(p.x,p.y);
  float r = length(p);
  r = (sin(abs(2.*sin(r + vol2 -u_time/3.)-(sin(u_time))))) - (-vol*1.2 + 0.8)*abs(sin(a*4.-u_time)*sin(r));
  vec3 color = getTweenedTexture(u_palette, r).rgb;
  gl_FragColor = length(vec4(r,r*r,.6,0.)) * vec4(color, sqrt(length(color)));
}
