#pragma glslify: import('../common.glsl')

#define LINE_COUNT 12

float getWeight(int i) {
  float ret = 0.0;
  float delta = 1.0 / (float(LINE_COUNT) * 2.);
  float index = float(i+1) / float(LINE_COUNT+1);
  ret += getFrequencyValue(index, FREQ_AMPLITUDE);
  ret += getFrequencyValue(index + delta, FREQ_AMPLITUDE);
  return ret;
}

float glow(float x) {
  return clamp(0.15 / pow(x, 0.5), 0., 1.);
}

void main() {
  vec2 uvTrue = gl_FragCoord.xy / u_resolution * 2.0;
  vec2 uv = -3.0 + 3.0 * uvTrue;
  vec3 color = vec3(0.0);

  for (int index = 0; index < LINE_COUNT; index++) {
    float i = float(index);

    // Figure out amplitude of segment.
    float amplitude = getWeight(index);

    // Offset each wave from each other, and add in a harmonic component based on frequency.
    uv.y += (0.15 * sin(uv.x + i/float(LINE_COUNT-1) - u_time * 0.8)) + 0.1 * sin(uv.x * 7.0 * amplitude);

    // Move the wave up based on amplitude.
    float glow = glow(abs(uv.y));
    color = max(color, glow * getTweenedTexture(u_palette, float(i)/float(LINE_COUNT)).rgb);
  }

  gl_FragColor = vec4(color, length(color));
}
