#pragma glslify: import('../common.glsl')

#define ITERATIONS 32

float m(vec3 p)
{
  p.y += 1.5*sin(p.x+u_time*2.);
  p.z += 2. * u_time;
  return length(.1*sin(p.x/1.5+p.y)+cos(p.zzx/4.))-.9;
}

vec3 rgb2hsv(vec3 c)
{
  vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
  vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
  vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

  float d = q.x - min(q.w, q.y);
  float e = 1.0e-10;
  return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

void main()
{
  vec3 d = .9 - vec3(gl_FragCoord.xy/.65,0) / u_resolution.x;
  vec3 o = d;

  for (int i=0; i<ITERATIONS; i++)
    o += m(o) * d + texture2D(u_frequencies, vec2(float(i)/float(ITERATIONS), 0)).x/1.2;

  gl_FragColor.a = 1.;
  vec3 rgb = abs(m(o*1.8)*vec3(.3+sin(o.x)/3.,.1,.1)+m(o*.5)*vec3(.1,.05,0))*(9.-o.y/3.);
  vec3 hsv = rgb2hsv(rgb);
  gl_FragColor.rgb = getTweenedTexture(u_palette, hsv.z).rgb;
  gl_FragColor.rgb = gl_FragColor.rgb * 0.7 + rgb * 0.3;
}
