#pragma glslify: import('../common.glsl')

vec3 triangle(vec2 uv, float ang, float zoom, vec3 c)
{
	float l = length(uv);
	float a = ang - atan(uv.x, uv.y);
	float m = (TWO_PI / 3.);
	a = mod(a + m / 2., m) - m / 2.;
	a = a + getFrequencyValueBilinear(uv.x / 2. + 0.5, FREQ_AMPLITUDE) * 1.8;
	float d = min(1.10 + sin(u_time)/3., 1.45)* 8. * abs(l * cos(a) - zoom);
	c = vec3(smoothstep(0.09, 0.015, d));
	return c;
}

void main()
{
	vec2 uv = (2. * gl_FragCoord.xy - u_resolution) / u_resolution.y;
	float t = u_time;
	vec3 col = vec3(0.0);

	for (float i=0.0; i<30.0; i++)
	{
	    vec3 color = getTweenedTexture(u_palette, i/29.).rgb;
		col += triangle(uv, 1.05 + sin(t + i*0.15), i/50., vec3(1.0)) * color;
	}

	gl_FragColor = vec4(col, sqrt(length(col)));
}
